var MHO_SHARE_URLBAR_LISTENER = {
	// { 'engine': 'google.com', 'term': 'term' }
	cache : [],
	
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
			aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
			aIID.equals(Components.interfaces.nsISupports))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},

	onLocationChange: function(aProgress, aRequest, aURI) {
		if (aURI) {
			var url = aURI.spec;
		
			if (url == content.document.location.href) {
				if (matches = url.match(/[\?&](q|p|w|wd|query|search|search_query|satitle)=([^&]+)/i)){
					if (MHOS_DEBUG) logMhoShareMsg("Search listener caught " + url);
				
					var keywords = decodeURIComponent(matches[2]).split("+").join(":");
				
					if (MHOS_DEBUG) logMhoShareMsg("Keywords for " + url + ": " + keywords);

					if (url == content.document.location.href) {
						if (MHO_SHARE.browser) {
							if (MHOS_DEBUG) logMhoShareMsg("Should be showing results in the sidebar...");
							
							MHO_SHARE.showResults(url, keywords, true);
						}
						else if (document.getElementById("sidebar-box").getAttribute("hidden") && MHO_SHARE.prefs.getBoolPref("autoPop")){
							// Check to ensure it hasn't already happened this session.
							var engine = url.split("//")[1].split("/")[0];
							var term = keywords.replace(/:/g, " ");
							
							for (var i = 0; i < this.cache.length; i++){
								if (this.cache[i].engine == engine && this.cache[i].term == term) {
									return;
								}
							}
							
							this.cache.push({ 'engine': engine, 'term': term });
							
							if (MHOS_DEBUG) logMhoShareMsg("Initializing autosearch...");
							MHO_SHARE.autoSearch(term);
						}
					}
				}
			}
		}
	},
	
	onStateChange : function() {},
	onProgressChange: function() {},
	onStatusChange: function() {},
	onSecurityChange: function() {},
	onLinkIconAvailable: function() {}
};

window.addEventListener("load", function (event) { gBrowser.addProgressListener(MHO_SHARE_URLBAR_LISTENER, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT); }, false);
window.addEventListener("unload", function (event) { gBrowser.removeProgressListener(MHO_SHARE_URLBAR_LISTENER); }, false);